/****************************************************************************/
/**    Kernel-AX25-Treiber fr GNOM.                                       **/
/**  Copyright (C) 1997 Jochen Sarrazin, DG6VJ. All righs reserved.        **/
/**                                                                        **/
/**  Konfigurations-Routinen                                               **/
/****************************************************************************/


#include "global.h"


static int anz_ports;
static int akt_port;

typedef struct
{
  char *portname;
  int t1;
  int t2;
  int t3;
  int idle;
  int n2;
  int window;
  int paclen;
} s_config_ctl;
s_config_ctl ctl[50];


/* Diese Rufzeichen werden sofort wieder disconnected, ohne da GNOM was davon mitbekommt */
void discon_addcalls(char *disconcalls)
{
  int i;
  char tmp[100],call[10];
  s_discon *disctmp;
  
  KillAllSpaces(tmp,disconcalls);
  Gross(tmp);
  
  while (tmp[0] != '\0')
  {
    if ((i = POS(',',tmp)) != -1)
    {
      COPY(call,tmp,0,i);
      COPY(tmp,tmp,i+1,strlen(tmp)-i-1);
    }
    else
    {
      strcpy(call,tmp);
      tmp[0] = '\0';
    }
    
    if (discroot == NULL)
    {
      discroot = (s_discon *)malloc(sizeof(s_discon));
      disctmp = discroot;
    }
    else
    {
      disctmp = discroot;
      while (disctmp->next != NULL) disctmp = disctmp->next;
      disctmp->next = (s_discon *)malloc(sizeof(s_discon));
      disctmp = disctmp->next;
    }
    
    disctmp->next = NULL;
    disctmp->call = (char *)strdup(call);
  }
}


void config_readconfig()
{
  int i,line,error=FALSE,found=FALSE;
  char str[500],tmp[500];
  FILE *fs;
  
  
  if ((fs = fopen("kax25.conf","r")) == NULL)
  {
    if ((fs = fopen("/etc/kax25.conf","r")) == NULL)
    {
      printf("ERROR! Neither ./kax25.conf nor /etc/kax25.conf were found!\n");
      exit(5);
    }
  }
  
  
  use_ports[0] = '\0';
  socket_path[0] = '\0';
  no_gnom_text[0] = '\0';
  anz_ports = 0;
  akt_port = -1;
  
  /* die s_config_ctl-Struktur leer machen */
  i = 0;
  while (i < 50)
  {
    ctl[i].portname = NULL;
    ctl[i].t1 = -1;
    ctl[i].t2 = -1;
    ctl[i].t3 = -1;
    ctl[i].idle = -1;
    ctl[i].n2 = -1;
    ctl[i].window = -1;
    ctl[i].paclen = -1;
    i++;
  }
  
  line = 0;
  while (fgets(str,499,fs) != NULL)
  {
    line++;
    if ((i = POS('\xA',str)) != -1) str[i] = '\0';
    strcpy(tmp,str);
    OnlyOneSpace(str,tmp);
    strcpy(tmp,str);
    KillSpacesLeft(str);
    KillSpacesRight(str);
    if (str[0] != '#') {
      if ((i = POS(' ',str)) == -1)
      {
        printf("kax25.conf: Error in line %i: No Parameter\n",line);
        error = TRUE;
      }
      else {
        found = FALSE;
        COPY(tmp,str,i+1,strlen(str)-i-1);
        str[i] = '\0';
        Gross(str);
        
        if ((!strcmp(str,"USE_PORTS")) && (!found))
        {
          tmp[88] = '\0';
          strcpy(use_ports,tmp);
          found = TRUE;
        }

        if ((!strcmp(str,"NO_GNOM_TEXT")) && (!found))
        {
          tmp[499] = '\0';
          strcpy(no_gnom_text,tmp);
          found = TRUE;
        }
        
        if ((!strcmp(str,"DISCONNECT")) && (!found))
        {
          discon_addcalls(tmp);
          found = TRUE;
        }
        
        if ((!strcmp(str,"SOCKET_PATH")) && (!found))
        {
          tmp[99] = '\0';
          strcpy(socket_path,tmp);
          found = TRUE;
        }
        
        if ((!strcmp(str,"PORT")) && (!found))
        {
          anz_ports++;
          akt_port++;
          ctl[akt_port].portname = (char *) strdup(tmp);
        }
        
        if ((!strcmp(str,"T1")) && (!found))
        {
          found = TRUE;
          if (anz_ports > 0)
             ctl[akt_port].t1 = atoi(tmp);
          else
          {
            printf("kax25.conf: Error in line %i: No ports defined before t1-statement!\n",line);
            error = TRUE;
          }
        }

        if ((!strcmp(str,"T2")) && (!found))
        {
          found = TRUE;
          if (anz_ports > 0)
             ctl[akt_port].t2 = atoi(tmp);
          else
          {
            printf("kax25.conf: Error in line %i: No ports defined before t2-statement!\n",line);
            error = TRUE;
          }
        }
        
        if ((!strcmp(str,"T3")) && (!found))
        {
          found = TRUE;
          if (anz_ports > 0)
             ctl[akt_port].t3 = atoi(tmp);
          else
          {
            printf("kax25.conf: Error in line %i: No ports defined before t3-statement!\n",line);
            error = TRUE;
          }
        }

        if ((!strcmp(str,"IDLE")) && (!found))
        {
          found = TRUE;
          if (anz_ports > 0)
             ctl[akt_port].idle = atoi(tmp);
          else
          {
            printf("kax25.conf: Error in line %i: No ports defined before idle-statement!\n",line);
            error = TRUE;
          }
        }

        if ((!strcmp(str,"N2")) && (!found))
        {
          found = TRUE;
          if (anz_ports > 0)
             ctl[akt_port].n2 = atoi(tmp);
          else
          {
            printf("kax25.conf: Error in line %i: No ports defined before n2-statement!\n",line);
            error = TRUE;
          }
        }
        
        if ((!strcmp(str,"WINDOW")) && (!found))
        {
          found = TRUE;
          if (anz_ports > 0)
             ctl[akt_port].window = atoi(tmp);
          else
          {
            printf("kax25.conf: Error in line %i: No ports defined before window-statement!\n",line);
            error = TRUE;
          }
        }
        
        if ((!strcmp(str,"PACLEN")) && (!found))
        {
          found = TRUE;
          if (anz_ports > 0)
             ctl[akt_port].paclen = atoi(tmp);
          else
          {
            printf("kax25.conf: Error in line %i: No ports defined before t1-statement!\n",line);
            error = TRUE;
          }
        }
      }
    }
  }
  
  if (socket_path[0] == '\0')
  {
    printf("kax25.conf: Missing line 'socket_path'!\n");
    error = TRUE;
  }
  
  if (use_ports[0] == '\0')
  {
    printf("kax25.conf: Missing line 'use_ports'!\n");
    error = TRUE;
  }
  
  fclose(fs);


  if (error) 
  {
    fflush(stdout);
    exit(5);
  }
  
}



/* Sucht sich die axctl-Infos aus der lokalen Struktur hier 'raus, und packt sie in die
 * ports-struktur fr alle, die leider beim Einlesen des Konfigurations-Files noch nicht
 * vorhanden war.
 */
void config_locallist2portslist()
{
  s_portinfo *ptmp;
  int found,i;
  
  ptmp = portsroot;
  
  while (ptmp != NULL)
  {
    /* Gucken, ob in unserem Array ein Port mit diesem Namen drin ist */
    i = 0;
    found = FALSE;
    while ((i < anz_ports) && (!found))
    {
      if (!strcmp(ptmp->name,ctl[i].portname))
      {
        /* JAU! Gefunden! */
        ptmp->t1 = ctl[i].t1;
        ptmp->t2 = ctl[i].t2;
        ptmp->t3 = ctl[i].t3;
        ptmp->idle = ctl[i].idle;
        ptmp->n2 = ctl[i].n2;
        ptmp->window = ctl[i].window;
        ptmp->paclen = ctl[i].paclen;
        
        found = TRUE;
      }
      i++;
    }
    ptmp = ptmp->next;
  }
}

